Attribute VB_Name = "advTrigfunc"
Rem Nonintrinsic trig functions 2002. ejo+pfm..
'Dim pi As Double
'pi = Atn(1) * 4
Public Function pi()
  pi = Atn(1) * 4
End Function
Public Function pi2()
  pi2 = Atn(1) * 8
End Function
'Secant
Public Function Sec(X)
   Sec = 1 / Cos(X)
End Function
'Cosecant
Public Function Cosec(X)
   Cosec = 1 / Sin(X)
End Function
'Cotangent
Public Function Cotan(X)
   Cotan = 1 / Tan(X)
End Function
'Inverse Sine
Public Function Arcsin(X)
   Arcsin = Atn(X / Sqr(-X * X + 1))
End Function
'Inverse Cosine
Public Function Arccos(X)
   Arccos = Atn(-X / Sqr(-X * X + 1)) + 2 * Atn(1)
End Function
'Inverse Secant
Public Function Arcsec(X)
   Arcsec = Atn(X / Sqr(X * X - 1)) + Sgn((X) - 1) * (2 * Atn(1))
End Function
'Inverse Cosecant
Public Function Arccosec(X)
   Arccosec = Atn(X / Sqr(X * X - 1)) + (Sgn(X) - 1) * (2 * Atn(1))
End Function
'Inverse Cotangent
Public Function Arccotan(X)
   Arccotan = Atn(X) + 2 * Atn(1)
End Function
'Hyperbolic Sine
Public Function HSin(X)
   HSin = (Exp(X) - Exp(-X)) / 2
End Function
'Hyperbolic Cosine
Public Function HCos(X)
   HCos = (Exp(X) + Exp(-X)) / 2
End Function
'Hyperbolic Tangent
Public Function HTan(X)
   HTan = (Exp(X) - Exp(-X)) / (Exp(X) + Exp(-X))
End Function
'Hyperbolic Secant
Public Function HSec(X)
   HSec = 2 / (Exp(X) + Exp(-X))
End Function
'Hyperbolic Cosecant
Public Function HCosec(X)
   HCosec = 2 / (Exp(X) - Exp(-X))
End Function
'Hyperbolic Cotangent
Public Function HCotan(X)
   HCotan = (Exp(X) + Exp(-X)) / (Exp(X) - Exp(-X))
End Function
'Inverse Hyperbolic Sine
Public Function HArcsin(X)
   HArcsin = Log(X + Sqr(X * X + 1))
End Function
'Inverse Hyperbolic Cosine
Public Function HArccos(X)
   HArccos = Log(X + Sqr(X * X - 1))
End Function
'Inverse Hyperbolic Tangent
Public Function HArctan(X)
   HArctan = Log((1 + X) / (1 - X)) / 2
End Function
'Inverse Hyperbolic Secant
Public Function HArcsec(X)
   HArcsec = Log((Sqr(-X * X + 1) + 1) / X)
End Function
'Inverse Hyperbolic Cosecant
Public Function HArccosec(X)
   HArccosec = Log((Sgn(X) * Sqr(X * X + 1) + 1) / X)
End Function
'Inverse Hyperbolic Cotangent
Public Function HArccotan(X)
   HArccotan = Log((X + 1) / (X - 1)) / 2
End Function
'Logarithm to base N
Public Function LogN(N, X)
   LogN = Log(X) / Log(N)
End Function
'Pythagorean
Public Function Hypotenuse1(a, b)
   Hypotenuse = Sqr(a * a + b * b)
End Function
'Pythagorean
Public Function Hypotenuse2(a, b, c)
   Hypotenuse = Sqr(a * a + b * b + c * c)
End Function
'Distance formula?
Public Function rho#(ntheta#, a!, b!)
  rho# = 1 / Sqr((Cos(ntheta#) / a!) ^ 2 + (Sin(ntheta#) / b!) ^ 2)
End Function

