Attribute VB_Name = "rotate_matrix"
Option Explicit   ' neccesary?

Dim g As Integer, h As Integer
'Public thestar As Single, omstar As Single, phistar As Single
Dim cntrl_mtrx() As Single
Dim cntrl_mtrx_T() As Single
Dim cntrl_last() As Single
Dim cntrl_trnsfr() As Single
Dim cntrl_hold() As Single
Dim the_mtrx() As Single             ' these matrices in single precision for now so i can test
Dim phi_mtrx() As Single             ' for vector decay due to cut-off (truncation) error
Dim ohm_mtrx() As Single
Dim vctr_ident() As Single   ' this is not used but may need be in future
Dim cntrl_temp() As Single
Dim temp_last() As Single
Public Sub matrix_transfer()
'cv_11_nm1 = cv_11: cv_12_nm1 = cv_12: cv_13_nm1 = cv_13
'cv_21_nm1 = cv_21: cv_22_nm1 = cv_22: cv_23_nm1 = cv_23
'cv_31_nm1 = cv_31: cv_32_nm1 = cv_32: cv_33_nm1 = cv_33

For g = 1 To 3
   For h = 1 To 3
      cntrl_last(g, h) = cntrl_mtrx(g, h)
   Next
Next

End Sub
Public Sub temp_transfer()

For g = 1 To 3
   For h = 1 To 3
      temp_last(g, h) = cntrl_temp(g, h)
   Next
Next
End Sub


Public Sub cntrl_transpose()        ' this is not used (yet?)

'For g = 1 To 3
'   For h = 1 To 3
'      mtrx_hold(g, h) = cntrl_mtrx(g, h)
'   Next
'Next

For g = 1 To 3
   For h = 1 To 3
      cntrl_mtrx_T(g, h) = cntrl_mtrx(h, g)
   Next
Next
End Sub

Public Sub trans_phi(phistar)

If Form1.fixed Then       ' for fixed axis reference to screen axes

   cntrl_mtrx(1, 1) = cntrl_last(1, 1) * Cos(phistar) + cntrl_last(1, 3) * Sin(phistar)
   cntrl_mtrx(1, 2) = cntrl_last(1, 2)
   cntrl_mtrx(1, 3) = cntrl_last(1, 1) * -Sin(phistar) + cntrl_last(1, 3) * Cos(phistar)

   cntrl_mtrx(2, 1) = cntrl_last(2, 1) * Cos(phistar) + cntrl_last(2, 3) * Sin(phistar)
   cntrl_mtrx(2, 2) = cntrl_last(2, 2)
   cntrl_mtrx(2, 3) = cntrl_last(2, 1) * -Sin(phistar) + cntrl_last(2, 3) * Cos(phistar)

   cntrl_mtrx(3, 1) = cntrl_last(3, 1) * Cos(phistar) + cntrl_last(3, 3) * Sin(phistar)
   cntrl_mtrx(3, 2) = cntrl_last(3, 2)
   cntrl_mtrx(3, 3) = cntrl_last(3, 1) * -Sin(phistar) + cntrl_last(3, 3) * Cos(phistar)

Else           '  for control or floating axis reference, upon reference to screen axes

   phi_mtrx(1, 1) = Cos(phistar): phi_mtrx(1, 3) = -Sin(phistar)
   phi_mtrx(2, 2) = 1
   phi_mtrx(3, 1) = Sin(phistar): phi_mtrx(3, 3) = Cos(phistar)

   
   cntrl_mtrx(1, 1) = phi_mtrx(1, 1) * cntrl_last(1, 1) + phi_mtrx(1, 2) * cntrl_last(2, 1) + phi_mtrx(1, 3) * cntrl_last(3, 1)
   cntrl_mtrx(1, 2) = phi_mtrx(1, 1) * cntrl_last(1, 2) + phi_mtrx(1, 2) * cntrl_last(2, 2) + phi_mtrx(1, 3) * cntrl_last(3, 2)
   cntrl_mtrx(1, 3) = phi_mtrx(1, 1) * cntrl_last(1, 3) + phi_mtrx(1, 2) * cntrl_last(2, 3) + phi_mtrx(1, 3) * cntrl_last(3, 3)
   
   cntrl_mtrx(2, 1) = phi_mtrx(2, 1) * cntrl_last(1, 1) + phi_mtrx(2, 2) * cntrl_last(2, 1) + phi_mtrx(2, 3) * cntrl_last(3, 1)
   cntrl_mtrx(2, 2) = phi_mtrx(2, 1) * cntrl_last(1, 2) + phi_mtrx(2, 2) * cntrl_last(2, 2) + phi_mtrx(2, 3) * cntrl_last(3, 2)
   cntrl_mtrx(2, 3) = phi_mtrx(2, 1) * cntrl_last(1, 3) + phi_mtrx(2, 2) * cntrl_last(2, 3) + phi_mtrx(2, 3) * cntrl_last(3, 3)
   
   cntrl_mtrx(3, 1) = phi_mtrx(3, 1) * cntrl_last(1, 1) + phi_mtrx(3, 2) * cntrl_last(2, 1) + phi_mtrx(3, 3) * cntrl_last(3, 1)
   cntrl_mtrx(3, 2) = phi_mtrx(3, 1) * cntrl_last(1, 2) + phi_mtrx(3, 2) * cntrl_last(2, 2) + phi_mtrx(3, 3) * cntrl_last(3, 2)
   cntrl_mtrx(3, 3) = phi_mtrx(3, 1) * cntrl_last(1, 3) + phi_mtrx(3, 2) * cntrl_last(2, 3) + phi_mtrx(3, 3) * cntrl_last(3, 3)

End If

End Sub

Public Sub trans_ohm(omstar)

If Form1.fixed = True Then

   cntrl_mtrx(1, 1) = cntrl_last(1, 1)
   cntrl_mtrx(1, 2) = cntrl_last(1, 2) * Cos(omstar) + cntrl_last(1, 3) * -Sin(omstar)
   cntrl_mtrx(1, 3) = cntrl_last(1, 2) * Sin(omstar) + cntrl_last(1, 3) * Cos(omstar)

   cntrl_mtrx(2, 1) = cntrl_last(2, 1)
   cntrl_mtrx(2, 2) = cntrl_last(2, 2) * Cos(omstar) + cntrl_last(2, 3) * -Sin(omstar)
   cntrl_mtrx(2, 3) = cntrl_last(2, 2) * Sin(omstar) + cntrl_last(2, 3) * Cos(omstar)

   cntrl_mtrx(3, 1) = cntrl_last(3, 1)
   cntrl_mtrx(3, 2) = cntrl_last(3, 2) * Cos(omstar) + cntrl_last(3, 3) * -Sin(omstar)
   cntrl_mtrx(3, 3) = cntrl_last(3, 2) * Sin(omstar) + cntrl_last(3, 3) * Cos(omstar)

Else

   ohm_mtrx(1, 1) = 1
   ohm_mtrx(2, 2) = Cos(omstar): ohm_mtrx(2, 3) = Sin(omstar)
   ohm_mtrx(3, 2) = -Sin(omstar): ohm_mtrx(3, 3) = Cos(omstar)

   cntrl_mtrx(1, 1) = ohm_mtrx(1, 1) * cntrl_last(1, 1) + ohm_mtrx(1, 2) * cntrl_last(2, 1) + ohm_mtrx(1, 3) * cntrl_last(3, 1)
   cntrl_mtrx(1, 2) = ohm_mtrx(1, 1) * cntrl_last(1, 2) + ohm_mtrx(1, 2) * cntrl_last(2, 2) + ohm_mtrx(1, 3) * cntrl_last(3, 2)
   cntrl_mtrx(1, 3) = ohm_mtrx(1, 1) * cntrl_last(1, 3) + ohm_mtrx(1, 2) * cntrl_last(2, 3) + ohm_mtrx(1, 3) * cntrl_last(3, 3)
   
   cntrl_mtrx(2, 1) = ohm_mtrx(2, 1) * cntrl_last(1, 1) + ohm_mtrx(2, 2) * cntrl_last(2, 1) + ohm_mtrx(2, 3) * cntrl_last(3, 1)
   cntrl_mtrx(2, 2) = ohm_mtrx(2, 1) * cntrl_last(1, 2) + ohm_mtrx(2, 2) * cntrl_last(2, 2) + ohm_mtrx(2, 3) * cntrl_last(3, 2)
   cntrl_mtrx(2, 3) = ohm_mtrx(2, 1) * cntrl_last(1, 3) + ohm_mtrx(2, 2) * cntrl_last(2, 3) + ohm_mtrx(2, 3) * cntrl_last(3, 3)
   
   cntrl_mtrx(3, 1) = ohm_mtrx(3, 1) * cntrl_last(1, 1) + ohm_mtrx(3, 2) * cntrl_last(2, 1) + ohm_mtrx(3, 3) * cntrl_last(3, 1)
   cntrl_mtrx(3, 2) = ohm_mtrx(3, 1) * cntrl_last(1, 2) + ohm_mtrx(3, 2) * cntrl_last(2, 2) + ohm_mtrx(3, 3) * cntrl_last(3, 2)
   cntrl_mtrx(3, 3) = ohm_mtrx(3, 1) * cntrl_last(1, 3) + ohm_mtrx(3, 2) * cntrl_last(2, 3) + ohm_mtrx(3, 3) * cntrl_last(3, 3)

End If
End Sub

Public Sub trans_the(thestar)

If Form1.fixed Then

   cntrl_mtrx(1, 1) = cntrl_last(1, 1) * Cos(thestar) + cntrl_last(1, 2) * -Sin(thestar)
   cntrl_mtrx(1, 2) = cntrl_last(1, 1) * Sin(thestar) + cntrl_last(1, 2) * Cos(thestar)
   cntrl_mtrx(1, 3) = cntrl_last(1, 3)

   cntrl_mtrx(2, 1) = cntrl_last(2, 1) * Cos(thestar) + cntrl_last(2, 2) * -Sin(thestar)
   cntrl_mtrx(2, 2) = cntrl_last(2, 1) * Sin(thestar) + cntrl_last(2, 2) * Cos(thestar)
   cntrl_mtrx(2, 3) = cntrl_last(2, 3)

   cntrl_mtrx(3, 1) = cntrl_last(3, 1) * Cos(thestar) + cntrl_last(3, 2) * -Sin(thestar)
   cntrl_mtrx(3, 2) = cntrl_last(3, 1) * Sin(thestar) + cntrl_last(3, 2) * Cos(thestar)
   cntrl_mtrx(3, 3) = cntrl_last(3, 3)

Else

   the_mtrx(1, 1) = Cos(thestar): the_mtrx(1, 2) = Sin(thestar)
   the_mtrx(2, 1) = -Sin(thestar): the_mtrx(2, 2) = Cos(thestar)
   the_mtrx(3, 3) = 1

   cntrl_mtrx(1, 1) = the_mtrx(1, 1) * cntrl_last(1, 1) + the_mtrx(1, 2) * cntrl_last(2, 1) + the_mtrx(1, 3) * cntrl_last(3, 1)
   cntrl_mtrx(1, 2) = the_mtrx(1, 1) * cntrl_last(1, 2) + the_mtrx(1, 2) * cntrl_last(2, 2) + the_mtrx(1, 3) * cntrl_last(3, 2)
   cntrl_mtrx(1, 3) = the_mtrx(1, 1) * cntrl_last(1, 3) + the_mtrx(1, 2) * cntrl_last(2, 3) + the_mtrx(1, 3) * cntrl_last(3, 3)
   
   cntrl_mtrx(2, 1) = the_mtrx(2, 1) * cntrl_last(1, 1) + the_mtrx(2, 2) * cntrl_last(2, 1) + the_mtrx(2, 3) * cntrl_last(3, 1)
   cntrl_mtrx(2, 2) = the_mtrx(2, 1) * cntrl_last(1, 2) + the_mtrx(2, 2) * cntrl_last(2, 2) + the_mtrx(2, 3) * cntrl_last(3, 2)
   cntrl_mtrx(2, 3) = the_mtrx(2, 1) * cntrl_last(1, 3) + the_mtrx(2, 2) * cntrl_last(2, 3) + the_mtrx(2, 3) * cntrl_last(3, 3)
   
   cntrl_mtrx(3, 1) = the_mtrx(3, 1) * cntrl_last(1, 1) + the_mtrx(3, 2) * cntrl_last(2, 1) + the_mtrx(3, 3) * cntrl_last(3, 1)
   cntrl_mtrx(3, 2) = the_mtrx(3, 1) * cntrl_last(1, 2) + the_mtrx(3, 2) * cntrl_last(2, 2) + the_mtrx(3, 3) * cntrl_last(3, 2)
   cntrl_mtrx(3, 3) = the_mtrx(3, 1) * cntrl_last(1, 3) + the_mtrx(3, 2) * cntrl_last(2, 3) + the_mtrx(3, 3) * cntrl_last(3, 3)

End If

End Sub

Public Sub matrix_multiply()

'cntrl_transpose

'For g = 1 To 3
'   For h = 1 To 3
'      cntrl_mtrx(g, h) = cntrl_mtrx(g, h) * cntrl_mtrx_T(g, h)
'   Next
'Next


'Form1.deltx = Form1.rx * (cv_11 + cv_12 + cv_13)
'Form1.delty = Form1.ry * (cv_21 + cv_22 + cv_23)
'Form1.deltz = Form1.rz * (cv_31 + cv_32 + cv_33)

'If fixed Then

Form1.deltx = Form1.rx * cntrl_mtrx(1, 1) + Form1.ry * cntrl_mtrx(2, 1) + Form1.rz * cntrl_mtrx(3, 1)
Form1.delty = Form1.rx * cntrl_mtrx(1, 2) + Form1.ry * cntrl_mtrx(2, 2) + Form1.rz * cntrl_mtrx(3, 2)
Form1.deltz = Form1.rx * cntrl_mtrx(1, 3) + Form1.ry * cntrl_mtrx(2, 3) + Form1.rz * cntrl_mtrx(3, 3)

End Sub
Public Sub temp_cntrl()    ' i don't think this is being used, if i remember correctly it was not
For g = 1 To 3             ' necessary to set temp_last matrix at hand-off from mode to mode
   For h = 1 To 3
      temp_last(g, h) = cntrl_mtrx(g, h)
   Next
Next

End Sub

Public Sub compound_rotate(thestar)   ' this tests a rotation upon a rotation:  theta is second rotate

If Form1.fixed Then

   cntrl_temp(1, 1) = temp_last(1, 1) * Cos(thestar) + temp_last(1, 2) * -Sin(thestar)
   cntrl_temp(1, 2) = temp_last(1, 1) * Sin(thestar) + temp_last(1, 2) * Cos(thestar)
   cntrl_temp(1, 3) = temp_last(1, 3)

   cntrl_temp(2, 1) = temp_last(2, 1) * Cos(thestar) + temp_last(2, 2) * -Sin(thestar)
   cntrl_temp(2, 2) = temp_last(2, 1) * Sin(thestar) + temp_last(2, 2) * Cos(thestar)
   cntrl_temp(2, 3) = temp_last(2, 3)

   cntrl_temp(3, 1) = temp_last(3, 1) * Cos(thestar) + temp_last(3, 2) * -Sin(thestar)
   cntrl_temp(3, 2) = temp_last(3, 1) * Sin(thestar) + temp_last(3, 2) * Cos(thestar)
   cntrl_temp(3, 3) = temp_last(3, 3)

Else

   the_mtrx(1, 1) = Cos(thestar): the_mtrx(1, 2) = Sin(thestar)  ' put these public in sub ??
   the_mtrx(2, 1) = -Sin(thestar): the_mtrx(2, 2) = Cos(thestar)
   the_mtrx(3, 3) = 1

   cntrl_temp(1, 1) = the_mtrx(1, 1) * temp_last(1, 1) + the_mtrx(1, 2) * temp_last(2, 1) + the_mtrx(1, 3) * temp_last(3, 1)
   cntrl_temp(1, 2) = the_mtrx(1, 1) * temp_last(1, 2) + the_mtrx(1, 2) * temp_last(2, 2) + the_mtrx(1, 3) * temp_last(3, 2)
   cntrl_temp(1, 3) = the_mtrx(1, 1) * temp_last(1, 3) + the_mtrx(1, 2) * temp_last(2, 3) + the_mtrx(1, 3) * temp_last(3, 3)
   
   cntrl_temp(2, 1) = the_mtrx(2, 1) * temp_last(1, 1) + the_mtrx(2, 2) * temp_last(2, 1) + the_mtrx(2, 3) * temp_last(3, 1)
   cntrl_temp(2, 2) = the_mtrx(2, 1) * temp_last(1, 2) + the_mtrx(2, 2) * temp_last(2, 2) + the_mtrx(2, 3) * temp_last(3, 2)
   cntrl_temp(2, 3) = the_mtrx(2, 1) * temp_last(1, 3) + the_mtrx(2, 2) * temp_last(2, 3) + the_mtrx(2, 3) * temp_last(3, 3)
   
   cntrl_temp(3, 1) = the_mtrx(3, 1) * temp_last(1, 1) + the_mtrx(3, 2) * temp_last(2, 1) + the_mtrx(3, 3) * temp_last(3, 1)
   cntrl_temp(3, 2) = the_mtrx(3, 1) * temp_last(1, 2) + the_mtrx(3, 2) * temp_last(2, 2) + the_mtrx(3, 3) * temp_last(3, 2)
   cntrl_temp(3, 3) = the_mtrx(3, 1) * temp_last(1, 3) + the_mtrx(3, 2) * temp_last(2, 3) + the_mtrx(3, 3) * temp_last(3, 3)

End If

End Sub
Public Sub matrix_compound()  ' this is matrix control under compound rotation

Form1.deltx = Form1.rx * cntrl_temp(1, 1) + Form1.ry * cntrl_temp(2, 1) + Form1.rz * cntrl_temp(3, 1)
Form1.delty = Form1.rx * cntrl_temp(1, 2) + Form1.ry * cntrl_temp(2, 2) + Form1.rz * cntrl_temp(3, 2)
Form1.deltz = Form1.rx * cntrl_temp(1, 3) + Form1.ry * cntrl_temp(2, 3) + Form1.rz * cntrl_temp(3, 3)

End Sub


Public Sub control_matrix()       ' this does not exist !!

End Sub

Public Sub identity_set()   ' set the identity matrices for initial states ::
                            ' set the control matrix to the identity for first orientation (screen axes)
ReDim cntrl_mtrx(3, 3)      ' set the vector identity matrix to the identity state (first iteration)
'ReDim cntrl_mtrx_T(3, 3)   '    huh     the vector identity matrix is not needed.
ReDim cntrl_last(3, 3)      ' note for future testing:  check the control vector (orientation vector)
ReDim cntrl_trnsfr(3, 3)    ' for decay of its length (absolute magnitude) from 1.0
ReDim cntrl_hold(3, 3)      '
                            ' turns out the cntrl_mtrx IS the vctr_ident (3,3) matrix
ReDim the_mtrx(3, 3)
ReDim phi_mtrx(3, 3)
ReDim ohm_mtrx(3, 3)
ReDim vctr_ident(3, 3)
ReDim cntrl_temp(3, 3)
ReDim temp_last(3, 3)

cntrl_mtrx(1, 1) = 1: cntrl_mtrx(1, 2) = 0: cntrl_mtrx(1, 3) = 0
cntrl_mtrx(2, 1) = 0: cntrl_mtrx(2, 2) = 1: cntrl_mtrx(2, 3) = 0
cntrl_mtrx(3, 1) = 0: cntrl_mtrx(3, 2) = 0: cntrl_mtrx(3, 3) = 1

vctr_ident(1, 1) = 1: vctr_ident(1, 2) = 0: vctr_ident(1, 3) = 0  ' these are not used !! (yet??)
vctr_ident(2, 1) = 0: vctr_ident(2, 2) = 1: vctr_ident(2, 3) = 0
vctr_ident(3, 1) = 0: vctr_ident(3, 2) = 0: vctr_ident(3, 3) = 1

'cntrl_last(1, 1) = 0: cntrl_last(1, 2) = 0: cntrl_last(1, 3) = 0
'cntrl_last(2, 1) = 0: cntrl_last(2, 2) = 0: cntrl_last(2, 3) = 0
'cntrl_last(3, 1) = 0: cntrl_last(3, 2) = 0: cntrl_last(3, 3) = 0

End Sub
