Attribute VB_Name = "sphere_cntrl"
Option Explicit  ' module for control sphere
Public longtitudes '= 6
Public latitudes '= 7
Public pix '= 108.1 ' pixels per inch, x_flat screen reference
Public pix2 '= 1.081
Public dtln '= 0.01

'Public longtitudes '= 6
'Public latitudes '= 7
'Public pix '= 108.1 ' pixels per inch, x_flat screen reference
'Public pix2 '= 1.081
'Public dtln '= 0.01


Public cvctr1()  'control circle datapoints store arrays, virtual prime space
Public cvctr2()
Public last1(), last2() ', last3()
Public lastL(), endlm_lst()
Public nline1()   'line store and line erase arrays  [architype and position memory]
Public eline1()
Public nline2()
Public eline2()
Public nline3()
Public eline3()
Dim abr As Single, endlm As Single, ln_nmbr As Integer
Dim rxf As Single, ryf As Single, rzf As Single
Dim rxo As Single, ryo As Single, rzo As Single
Dim dirx As Single, diry As Single, dirz As Single
Dim addx As Single, addy As Single, addz As Single
Dim lngt As Integer, lngtf As Integer, epi As Single, latd As Integer, ldta As Integer, nline As Integer, ndta As Integer
Public matrix_flag As Boolean

Public Sub gensphere()
If diamond_4d.user_flag Then GoTo spherestart
If Form1.radiusflag Or Form1.Rdpl Or Form1.Rdmn Then GoTo spherestart

Rem module-to-module variable call...
'sphere_cntrl.abr = 1

Rem module-to-module function call...
'call diamond_4d.cntrl_diamond
'diamond_4d.user_flag = False

 longtitudes = 6
 latitudes = 7
 pix = 108.1 ' pixels per inch, x_flat screen reference
 pix2 = 1.081
 dtln = 0.01


'Form1.longtitudes = 6
'Form1.latitudes = 7
'Form1.pix = 108.1
'Form1.pix2 = 1.081
'Form1.dtln = 0.01

Form1.dpts = 360
Form1.endl = Form1.dpts

Form1.radius = 2 '1.4

Form1.xref = 0
Form1.yref = 0
Form1.zref = 1.5

Form1.setx = Form1.Picture1.ScaleWidth / 2 + 100
Form1.sety = Form1.Picture1.ScaleHeight / 2 - 70
        
'Form1.thestar = 0 '-9 * pi / 128
'Form1.phistar = 0 'pi / 2
'Form1.omstar = 0 '11 * pi / 128

Form1.delthestar = pi / 128
Form1.delphistar = Form1.delthestar
Form1.delomstar = Form1.delthestar
Form1.delphistar2 = Form1.delphistar
   
Form1.bright_cntrl = True
Form1.cmdBright.Caption = "bright off"
Form1.cmdRdpl.Caption = "+ radius"
Form1.cmdRdmn.Caption = "-- radius"

Form1.restart = True
Form1.m_cntrl = True
'Form1.m_scale = True
Form1.fixed = False
Form1.cmd_guide.Caption = "float mode"

ReDim cvctr1(longtitudes, Form1.dpts, 3)
ReDim cvctr2(latitudes, Form1.dpts, 3)
'ReDim cvctr3(dpts, 3)

ReDim last1(longtitudes, Form1.dpts, 3) 'circle erase last data array store space
ReDim last2(latitudes, Form1.dpts, 3)
'ReDim last3(Form1.dpts, 3)

ReDim nline1(301, 3)   'line store and line erase arrays  [architype and position memory]
ReDim eline1(301, 3)
ReDim nline2(301, 3)
ReDim eline2(301, 3)
ReDim nline3(301, 3)
ReDim eline3(301, 3)

Form1.ln_nmbr = 1
Form1.lines = 6
Form1.endlmx = 800

ReDim lastL(6, 800, 4)
ReDim endlm_lst(6)

'form1.matrix_flag = True
Call identity_set
   
   phistar = 5 * pi / 12
   Call matrix_transfer
   Call trans_phi(phistar)
   thestar = 7 * pi / 12
   Call matrix_transfer
   Call trans_the(thestar)
   thestar = 0
   phistar = 0

spherestart:

lngtf = longtitudes
For lngt = 1 To lngtf
 
   Form1.longset = (lngt - 1) * pi / lngtf
   Form1.ndta = 0
   For epi = pi / Form1.dpts To 2 * pi Step 2 * pi / Form1.dpts
 
      Form1.ndta = Form1.ndta + 1
  
      Form1.rx = Form1.radius * Cos(epi) '* Cos(longset)
      Form1.rytmp = Form1.radius * Sin(epi) '* Sin(longset)
      Form1.rztmp = 0
   
      Form1.ry = Form1.rytmp * Cos(Form1.longset)
      Form1.rz = Form1.rytmp * Sin(Form1.longset)
   
      cvctr1(lngt, Form1.ndta, 1) = Form1.rx
      cvctr1(lngt, Form1.ndta, 2) = Form1.ry
      cvctr1(lngt, Form1.ndta, 3) = Form1.rz
   Next

Next

For latd = 1 To latitudes

   Form1.latangle = latd * pi / (latitudes + 1)
'   Rx = radius * (1 - 2 * latd / (latitudes + 1))
   Form1.rx = Form1.radius * Sin(pi / 2 - Form1.latangle)
   
   'Ry = radius * Cos(epi)
   'Rz = radius * Sin(epi)

   'radius2 = Sqr(Ry ^ 2 + Rz ^ 2)
   
   Form1.ndta = 0
   For epi = pi / Form1.dpts To 2 * pi Step 2 * pi / Form1.dpts

      Form1.ndta = Form1.ndta + 1
  
   'Rx = 0
      Form1.rytmp = Form1.radius * Cos(epi)
      Form1.rztmp = Form1.radius * Sin(epi)
      Form1.rxcos2 = 1 - (Form1.rx / Form1.radius) ^ 2
      Form1.radius2 = Sqr(Form1.rxcos2)
'      radius2 = Sin(Atn(RyTmp / Rx))
   
      Form1.ry = Form1.radius2 * Form1.rytmp
      Form1.rz = Form1.radius2 * Form1.rztmp
   
      cvctr2(latd, Form1.ndta, 1) = Form1.rx
      cvctr2(latd, Form1.ndta, 2) = Form1.ry
      cvctr2(latd, Form1.ndta, 3) = Form1.rz
   Next
Next

' generate axis lines:
ldta = 0
For nline = -150 To 150 Step 1

   ldta = ldta + 1
 
   If ldta <= 100 Then addx = -4.5
   If ldta > 100 And ldta <= 200 Then addx = -1.5
   If ldta > 200 And ldta <= 300 Then addx = 1.5
  
   Form1.rx = Form1.radius / 3 * (ldta * 0.01 + addx)
   Form1.ry = 0
   Form1.rz = 0

   nline1(ldta, 1) = Form1.rx
   nline1(ldta, 2) = Form1.ry
   nline1(ldta, 3) = Form1.rz
Next

ldta = 0
For nline = -150 To 150 Step 1

   ldta = ldta + 1

   If ldta <= 100 Then addy = -3.9 '-4.5
   If ldta > 100 And ldta <= 200 Then addy = -1.5
   If ldta > 200 And ldta <= 300 Then addy = 0.9 '1.5
 
   Form1.rx = 0
   Form1.ry = Form1.radius / 3 * (ldta * 0.01 + addy)
   Form1.rz = 0

   nline2(ldta, 1) = Form1.rx
   nline2(ldta, 2) = Form1.ry
   nline2(ldta, 3) = Form1.rz
Next

ldta = 0
For nline = -150 To 150 Step 1

   ldta = ldta + 1

   If ldta <= 100 Then addz = -3.9 '-4.5
   If ldta > 100 And ldta <= 200 Then addz = -1.5
   If ldta > 200 And ldta <= 300 Then addz = 0.9 '1.5

   Form1.rx = 0
   Form1.ry = 0
   Form1.rz = Form1.radius / 3 * (ldta * 0.01 + addz)

   nline3(ldta, 1) = Form1.rx
   nline3(ldta, 2) = Form1.ry
   nline3(ldta, 3) = Form1.rz
Next

'Call cntrl_transpose
'Call matrix_multiply

'   phistar = 5 * pi / 12
'   Call matrix_transfer
'   Call trans_phi(phistar)
'   thestar = 7 * pi / 12
'   Call matrix_transfer
'   Call trans_the(thestar)
'   thestar = 0
'   phistar = 0

End Sub

Public Sub controlsphere()

If Form1.restart Then 'And Not diamond_4d.user_flag Then
   omstar = -pi / 64
   Call matrix_transfer
   Call trans_ohm(omstar)
End If

For lngt = 1 To longtitudes

If diamond_4d.user_flag Then GoTo long_start

For ndta = 1 To Form1.dpts

      Form1.clrcntrl = -1

      Form1.xprmI = last1(lngt, ndta, 1)
      Form1.yprmI = last1(lngt, ndta, 2)
      Form1.zprmI = last1(lngt, ndta, 3)
            
      Form1.imagine
      Form1.pointset
Next

long_start:

For ndta = 1 To Form1.dpts
    
      Form1.rx = cvctr1(lngt, ndta, 1)
      Form1.ry = cvctr1(lngt, ndta, 2)
      Form1.rz = cvctr1(lngt, ndta, 3)

      Form1.clrcntrl = 0

      If Form1.matrix_flag Then
         Call matrix_multiply
      Else
         Form1.rotate
      End If
      
      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)

      Form1.imagine
      Form1.pointset

      last1(lngt, ndta, 1) = Form1.xprmI
      last1(lngt, ndta, 2) = Form1.yprmI
      last1(lngt, ndta, 3) = Form1.zprmI
Next

Next

If diamond_4d.user_flag Then GoTo line_start1

For ldta = 1 To 300

      Form1.xprmI = eline1(ldta, 1)
      Form1.yprmI = eline1(ldta, 2)
      Form1.zprmI = eline1(ldta, 3)

      Form1.clrcntrl = -1

      Form1.imagine
      Form1.pointset
Next

line_start1:

For ldta = 1 To 300
   
      Form1.clrcntrl = 0
    
      Form1.rx = nline1(ldta, 1)
      Form1.ry = nline1(ldta, 2)
      Form1.rz = nline1(ldta, 3)

      'Form1.rotate
      
      
      
      If Form1.matrix_flag Then
         Call matrix_multiply
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)

      Form1.imagine
      Form1.pointset

      eline1(ldta, 1) = Form1.xprmI
      eline1(ldta, 2) = Form1.yprmI
      eline1(ldta, 3) = Form1.zprmI
Next

If diamond_4d.user_flag Then GoTo line_start2

For ldta = 1 To 300

      Form1.xprmI = eline2(ldta, 1)
      Form1.yprmI = eline2(ldta, 2)
      Form1.zprmI = eline2(ldta, 3)
  
      Form1.clrcntrl = -1
  
      Form1.imagine
      Form1.pointset
Next

line_start2:

For ldta = 1 To 300
  
      Form1.clrcntrl = 0
   
      Form1.rx = nline2(ldta, 1)
      Form1.ry = nline2(ldta, 2)
      Form1.rz = nline2(ldta, 3)

      'Form1.rotate
      If Form1.matrix_flag Then
         Call matrix_multiply
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)

      Form1.imagine
      Form1.pointset

      eline2(ldta, 1) = Form1.xprmI
      eline2(ldta, 2) = Form1.yprmI
      eline2(ldta, 3) = Form1.zprmI
Next

If diamond_4d.user_flag Then GoTo line_start3

For ldta = 1 To 300

      Form1.xprmI = eline3(ldta, 1)
      Form1.yprmI = eline3(ldta, 2)
      Form1.zprmI = eline3(ldta, 3)
 
      Form1.clrcntrl = -1
 
      Form1.imagine
      Form1.pointset
Next

line_start3:

For ldta = 1 To 300
 
      Form1.clrcntrl = 0
  
      Form1.rx = nline3(ldta, 1)
      Form1.ry = nline3(ldta, 2)
      Form1.rz = nline3(ldta, 3)

      'Form1.rotate
      If Form1.matrix_flag Then
         Call matrix_multiply
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)

      Form1.imagine
      Form1.pointset

      eline3(ldta, 1) = Form1.xprmI
      eline3(ldta, 2) = Form1.yprmI
      eline3(ldta, 3) = Form1.zprmI
Next

For latd = 1 To latitudes

   If diamond_4d.user_flag Then GoTo lat_start
      
   For ndta = 1 To Form1.dpts
      
      Form1.xprmI = last2(latd, ndta, 1)
      Form1.yprmI = last2(latd, ndta, 2)
      Form1.zprmI = last2(latd, ndta, 3)

      Form1.clrcntrl = -1
  
      Form1.imagine
      Form1.pointset
   Next

lat_start:

   For ndta = 1 To Form1.dpts

      Form1.clrcntrl = 0
     
      Form1.rx = cvctr2(latd, ndta, 1)
      Form1.ry = cvctr2(latd, ndta, 2)
      Form1.rz = cvctr2(latd, ndta, 3)

      'Form1.rotate
      If Form1.matrix_flag Then
         Call matrix_multiply
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)

      Form1.imagine
      Form1.pointset

      last2(latd, ndta, 1) = Form1.xprmI
      last2(latd, ndta, 2) = Form1.yprmI
      last2(latd, ndta, 3) = Form1.zprmI
   Next
Next
Exit Sub
End Sub
'Form1.rxo = -3.1: Form1.ryo = 0: Form1.rzo = 0 ' nothing below here will register
'Form1.rxf = -2.9: Form1.ryf = 0: Form1.rzf = 0 ' was this re-written out ??
'Form1.ln_nmbr = 1
'Form1.genline1
'Exit Sub

'rxo = 3.1: ryo = 0: rzo = 0
'rxf = 2.9: ryf = 0: rzf = 0
'ln_nmbr = 2
'GoSub genline1

'rxo = 0: ryo = 3: rzo = 0
'rxf = 0: ryf = 3.1: rzf = 0
'ln_nmbr = 3
'GoSub genline1

'rxo = 0: ryo = -3: rzo = 0
'rxf = 0: ryf = -3.1: rzf = 0
'ln_nmbr = 4
'GoSub genline1

'rxo = 0: ryo = 0: rzo = 3.1
'rxf = 0: ryf = 0: rzf = 3
'ln_nmbr = 5
'GoSub genline1

'rxo = 0: ryo = 0: rzo = -3
'rxf = 0: ryf = 0: rzf = -3.1
'ln_nmbr = 6
'GoSub genline1  ' okay we're using a local genline1 copy keep it local, check diamond_4d error.**

'Exit Sub

'genline1:   ' genline1 is already in form1 !!
'dirx = rxf - rxo: diry = ryf - ryo: dirz = rzf - rzo
'abr = Sqr(dirx ^ 2 + diry ^ 2 + dirz ^ 2)
'endlm = Int(100 * abr / dtln) / 100

'For nline = 0 To endlm

'   Form1.rx = rxo + nline * dirx / endlm
'   Form1.ry = ryo + nline * diry / endlm
'   Form1.rz = rzo + nline * dirz / endlm

'   'Form1.rotate
'      If Form1.matrix_flag Then
'         Call matrix_multiply
'      Else
'         Form1.rotate
'      End If

'   Form1.xprmI = pix * (Form1.xref + Form1.deltx)
'   Form1.yprmI = pix * (Form1.yref + Form1.delty)
'   Form1.zprmI = pix * (Form1.zref + Form1.deltz)
 
'   Form1.clrcntrl = 0

'   Form1.imagine
'   Form1.pointset


'   lastL(ln_nmbr, nline, 1) = Form1.ImL
'   lastL(ln_nmbr, nline, 2) = Form1.ImR
'   lastL(ln_nmbr, nline, 3) = Form1.ImY
'   lastL(ln_nmbr, nline, 4) = Form1.ImC

'Next
'endlm_lst(ln_nmbr) = endlm
''ln_nmbr_lst = ln_nmbr
'Return
'End Sub
