Attribute VB_Name = "apollo1"
Option Explicit

' note that pi is not defined here

'Public pix '= 108.1 ' pixels per inch, x_flat screen reference
'Public pix2 '= 1.081
Public dtln '= 0.01
Dim epi As Single
Dim dpts As Single
Dim pi2 As Single

Public rx As Single, ry As Single, rz As Single
Public rxx As Single, ryy As Single, rzz As Single
Public deltx As Single, delty As Single, deltz As Single
Public thestar As Single, phistar As Single, omstar As Single

Public nline1()   'line store and line erase arrays  [architype and position memory]
Public eline1()
Public nline2()
Public eline2()
Public nline3()
Public eline3()

Dim a_dta As Integer, a_star As Integer
Dim c_star As Integer
Dim l_dta As Long
Dim abr As Single, endlm As Single, ln_nmbr As Integer
Dim rxf As Single, ryf As Single, rzf As Single
Dim rxo As Single, ryo As Single, rzo As Single
Dim dirx As Single, diry As Single, dirz As Single

Dim a As Single, b As Single, c As Single
Dim mc As Single, mhp As Single
Dim X As Single, y As Single, z As Single
Dim z_c As Single, z_hp As Single

Dim offset_1 As Single

Public node As Integer
'Dim omstr_zero As Single, omstr_5 As Single
Dim thstr_zero As Single, thstr_5 As Single
Public thstrF As Single, phstrF As Single, omstrF As Single

Dim thstr_hold As Single, phstr_hold As Single, omstr_hold As Single
Dim thestar_hold As Single
Const pix As Single = 108.1 ' pixels per inch, x_flat screen reference
Const pix2 As Single = 1.081

'Public dirx As Single, diry As Single, dirz As Single
'Public abr As Single ', endlm As Single
'Public rxf As Single, ryf As Single, rzf As Single
'Public rxo As Single, ryo As Single, rzo As Single
'Public rxx As Single, ryy As Single, rzz As Single
'Public vline As Integer

Public n_line As Long
Public end_line As Long
Public quad As Integer


Public apollo_data_L()
Public apollo_data_R()
Public apollo_last_L()
Public apollo_last_R()

Public apollo_circle_cm_1()
Public apollo_circle_cm_2()
Public apollo_circle_sm_1()
Public apollo_circle_sm_2()
Public apollo_circle_sm_3()

Public apollo_circle_nz_1()
Public apollo_circle_nz_2()
Public apollo_circle_nz_3()
Public apollo_circle_nz_4()

Public cm_circle_last_1()
Public cm_circle_last_2()
Public sm_circle_last_1()
Public sm_circle_last_2()
Public sm_circle_last_3()

Public nz_circle_last_1()
Public nz_circle_last_2()
Public nz_circle_last_3()
Public nz_circle_last_4()

'Public cyl_line_outL()
'Public cyl_line_outR()
'Public cyl_line_in_L()
'Public cyl_line_in_R()

Dim end_cyl_line_A As Long
Dim end_cyl_line_B As Long
Dim cylndr_line_A() As Single
Dim cylndr_line_B() As Single

'Dim quarter As Integer

Public last_cyl_line_A()
Public last_cyl_line_B()
'Public last_cyl_line()
'Public last_cyl_line()




Public Sub apollo_gen_data()
 
If Form1.radiusflag Or Form1.Rdpl Or Form1.Rdmn Then GoTo apollo_start
pi2 = pi * 2   ' this should be in function form in advTrigfunc
dpts = 360
epi = pi2 / dpts
 'pix = 108.1 ' pixels per inch, x_flat screen reference
 'pix2 = 1.081
Form1.aleph = 0.6 '1
Form1.alphstep = 0.05

Form1.bright_cntrl = True
Form1.cmdBright.Caption = "bright off"
Form1.cmdRdpl.Caption = "+ aleph"
Form1.cmdRdmn.Caption = "-- aleph"

a = 1.82: c = 0.89
mc = -0.65414: mhp = -0.48911      ' conic hyperbola archetype parameters
z_c = 3.325: z_hp = 3.721
a_dta = 216
'c_end =
Const dtln = 0.01

ReDim apollo_data_L(5, a_dta, 3)
ReDim apollo_data_R(5, a_dta, 3)
ReDim apollo_last_L(5, a_dta, 3)
ReDim apollo_last_R(5, a_dta, 3)

ReDim apollo_circle_cm_1(dpts, 3)
ReDim apollo_circle_cm_2(dpts, 3)
ReDim apollo_circle_sm_1(dpts, 3)
ReDim apollo_circle_sm_2(dpts, 3)
ReDim apollo_circle_sm_3(dpts, 3)

ReDim apollo_circle_nz_1(dpts, 3)
ReDim apollo_circle_nz_2(dpts, 3)
ReDim apollo_circle_nz_3(dpts, 3)
ReDim apollo_circle_nz_4(dpts, 3)

ReDim cm_circle_last_1(dpts, 3)
ReDim cm_circle_last_2(dpts, 3)
ReDim sm_circle_last_1(dpts, 3)
ReDim sm_circle_last_2(dpts, 3)
ReDim sm_circle_last_3(dpts, 3)

ReDim nz_circle_last_1(dpts, 3)
ReDim nz_circle_last_2(dpts, 3)
ReDim nz_circle_last_3(dpts, 3)
ReDim nz_circle_last_4(dpts, 3)
  
  
  end_cyl_line_A = CLng(4.7 / dtln)
  end_cyl_line_B = CLng(4.925 / dtln)

ReDim last_cyl_line_A(2, 5, end_cyl_line_A, 4)
ReDim last_cyl_line_B(2, 5, end_cyl_line_B, 4)
ReDim cylndr_line_A(2, 5, end_cyl_line_A, 3)
ReDim cylndr_line_B(2, 5, end_cyl_line_B, 3)

'ReDim last_cyl_line(4, 5, end_cyl_line_A, 4)
'ReDim last_cyl_line(4, 5, end_cyl_line_B, 4)
'ReDim last_cyl_line(4, 5, end_cyl_line_B, 4)
   
        
   Form1.setx = Form1.Picture1.ScaleWidth / 2 + 100
   Form1.sety = Form1.Picture1.ScaleHeight / 2 - 70
 
   Form1.xref = -0.5
   Form1.yref = 0
   Form1.zref = 1
 
'   Form1.thestar = 0 '5 * pi / 128 ' -9 * pi / 128
'   Form1.phistar = 0 '0 'pi / 2
'   Form1.omstar = 0 '11 * pi / 128
      
   Form1.delthestar = pi / 128
   Form1.delphistar = Form1.delthestar
   Form1.delomstar = Form1.delthestar
   Form1.delphistar2 = Form1.delphistar / 2

   Form1.restart = False
   Form1.start_flag = True
   Form1.fixed = False
   Form1.cmd_guide.Caption = "float mode"

'omstr_5 = 2 * pi / 5
'omstr_zero = 0
thstr_5 = 2 * pi / 5
'thstr_zero = 0

offset_1 = Cos(pi / 60)

'form1.matrix_flag = True
Call identity_set

   phistar = -3 * pi / 12
   Call matrix_transfer
   Call trans_phi(phistar)
   omstar = pi / 12
   Call matrix_transfer
   Call trans_ohm(omstar)
   omstar = 0
   phistar = 0

apollo_start:

thstr_zero = 0

thstr_hold = Form1.thstrF        ' save rotateF fixed rotate data; using external subroutine that
phstr_hold = Form1.phstrF        ' main program (form1) uses and leaves "local data" each cycle.*
omstr_hold = Form1.omstrF        ' note rotateF has mixed mode error in it but works default.* mode

Form1.thstrF = 0: Form1.phstrF = 0: Form1.omstrF = 0

For node = 1 To 5      ' create conic hyperbola archetype
   
   'Form1.omstrF = omstr_zero + node * omstr_5
   Form1.thstrF = thstr_zero + node * thstr_5

   a_star = 0
   For z = 2.1512 To 0 Step -0.01
   
      a_star = a_star + 1
    
      X = -c / a * (z - z_hp)
      y = Sqr(a * X - X ^ 2 + c * (z - z_hp) + (mc * (z - z_c)) ^ 2)
      
      Form1.rxx = Form1.aleph * X: Form1.ryy = Form1.aleph * y: Form1.rzz = Form1.aleph * z
      Form1.rotateF
      
      apollo_data_L(node, a_star, 1) = Form1.deltx
      apollo_data_L(node, a_star, 2) = Form1.delty
      apollo_data_L(node, a_star, 3) = Form1.deltz
   
      Form1.ryy = -Form1.ryy
      Form1.rotateF
   
      apollo_data_R(node, a_star, 1) = Form1.deltx
      apollo_data_R(node, a_star, 2) = Form1.delty
      apollo_data_R(node, a_star, 3) = Form1.deltz
   
   Next
Next

'Form1.Picture1.CurrentX = 600: Form1.Picture1.CurrentY = 200
'Form1.Picture1.Print apollo_data_L(1, 1, 1)

' create circle data
z = 2.525
c_star = 0
For thstrF = epi To pi2 Step epi
    
    c_star = c_star + 1
    X = 0.5233 * Cos(thstrF)
    y = 0.5233 * Sin(thstrF)
'    Form1.rxx = Form1.aleph * X: Form1.ryy = Form1.aleph * y: Form1.rzz = Form1.aleph * z
    
'    Form1.rotateF
    apollo_circle_cm_1(c_star, 1) = X * Form1.aleph 'Form1.deltx
    apollo_circle_cm_1(c_star, 2) = y * Form1.aleph 'Form1.delty
    apollo_circle_cm_1(c_star, 3) = z * Form1.aleph 'Form1.deltz
Next

z = 0
c_star = 0
For thstrF = epi To pi2 Step epi
    
    c_star = c_star + 1
    X = 2.175 * Cos(thstrF)
    y = 2.175 * Sin(thstrF)
    'Form1.rxx = Form1.aleph * X: Form1.ryy = Form1.aleph * y: Form1.rzz = Form1.aleph * z
    
    'Form1.rotateF
    apollo_circle_cm_2(c_star, 1) = Form1.aleph * X 'deltx
    apollo_circle_cm_2(c_star, 2) = Form1.aleph * y 'delty
    apollo_circle_cm_2(c_star, 3) = Form1.aleph * z 'deltz
Next

z = -4.925
c_star = 0
For thstrF = epi To pi2 Step epi
    
    c_star = c_star + 1
    X = 1.455 * Cos(thstrF)     ' 1.825 on model>*ver:01
    y = 1.455 * Sin(thstrF)
    'Form1.rxx = Form1.aleph * X: Form1.ryy = Form1.aleph * y: Form1.rzz = Form1.aleph * z
    
    'Form1.rotateF
    apollo_circle_sm_1(c_star, 1) = Form1.aleph * X 'deltx
    apollo_circle_sm_1(c_star, 2) = Form1.aleph * y 'delty
    apollo_circle_sm_1(c_star, 3) = Form1.aleph * z 'deltz
Next


z = -4.7 '-4.925
c_star = 0
For thstrF = epi To pi2 Step epi
    
    c_star = c_star + 1
    X = 2.175 * Cos(thstrF)
    y = 2.175 * Sin(thstrF)
    'Form1.rxx = Form1.aleph * X: Form1.ryy = Form1.aleph * y: Form1.rzz = Form1.aleph * z
    
    'Form1.rotateF
    apollo_circle_sm_2(c_star, 1) = Form1.aleph * X 'deltx
    apollo_circle_sm_2(c_star, 2) = Form1.aleph * y 'delty
    apollo_circle_sm_2(c_star, 3) = Form1.aleph * z 'deltz
Next

z = -0.15
c_star = 0
For thstrF = epi To pi2 Step epi
    
    c_star = c_star + 1
    X = 1.455 * Cos(thstrF)     ' 1.825 on model>*ver:01
    y = 1.455 * Sin(thstrF)
    'Form1.rxx = Form1.aleph * X: Form1.ryy = Form1.aleph * y: Form1.rzz = Form1.aleph * z
    
    'Form1.rotateF
    apollo_circle_sm_3(c_star, 1) = Form1.aleph * X 'deltx
    apollo_circle_sm_3(c_star, 2) = Form1.aleph * y 'delty
    apollo_circle_sm_3(c_star, 3) = Form1.aleph * z 'deltz
Next


z = -4.7 '-4.925
c_star = 0
For thstrF = epi To pi2 Step epi
    
    c_star = c_star + 1
    X = 0.3 * Cos(thstrF)
    y = 0.3 * Sin(thstrF)
    'Form1.rxx = Form1.aleph * X: Form1.ryy = Form1.aleph * y: Form1.rzz = Form1.aleph * z
    
    'Form1.rotateF
    apollo_circle_nz_1(c_star, 1) = Form1.aleph * X 'deltx
    apollo_circle_nz_1(c_star, 2) = Form1.aleph * y 'delty
    apollo_circle_nz_1(c_star, 3) = Form1.aleph * z 'deltz
Next
z = -6.15
c_star = 0
For thstrF = epi To pi2 Step epi
    
    c_star = c_star + 1
    X = 1.05 * Cos(thstrF)
    y = 1.05 * Sin(thstrF)
    'Form1.rxx = Form1.aleph * X: Form1.ryy = Form1.aleph * y: Form1.rzz = Form1.aleph * z
    
    'Form1.rotateF
    apollo_circle_nz_2(c_star, 1) = Form1.aleph * X 'deltx
    apollo_circle_nz_2(c_star, 2) = Form1.aleph * y 'delty
    apollo_circle_nz_2(c_star, 3) = Form1.aleph * z 'deltz
Next

z = -6.45
c_star = 0
For thstrF = epi To pi2 Step epi
    
    c_star = c_star + 1
    X = 1.15 * Cos(thstrF)
    y = 1.15 * Sin(thstrF)
    'Form1.rxx = Form1.aleph * X: Form1.ryy = Form1.aleph * y: Form1.rzz = Form1.aleph * z
    
    'Form1.rotateF
    apollo_circle_nz_3(c_star, 1) = Form1.aleph * X 'deltx
    apollo_circle_nz_3(c_star, 2) = Form1.aleph * y 'delty
    apollo_circle_nz_3(c_star, 3) = Form1.aleph * z 'deltz
Next

z = -7.3
c_star = 0
For thstrF = epi To pi2 Step epi
    
    c_star = c_star + 1
    X = 1.3375 * Cos(thstrF)
    y = 1.3375 * Sin(thstrF)
    'Form1.rxx = Form1.aleph * X: Form1.ryy = Form1.aleph * y: Form1.rzz = Form1.aleph * z
    
    'Form1.rotateF
    apollo_circle_nz_4(c_star, 1) = Form1.aleph * X 'deltx
    apollo_circle_nz_4(c_star, 2) = Form1.aleph * y 'delty
    apollo_circle_nz_4(c_star, 3) = Form1.aleph * z 'deltz
Next

'Form1.thstrF = thstr_5 / 2
'Form1.thstrF = Form1.thstrF + thstr_5

' create line data (service module)
For node = 1 To 5
   Form1.thstrF = node * thstr_5 - thstr_5 / 2

   end_line = end_cyl_line_A
   
   Form1.rxo = 2.175 * offset_1 * Form1.aleph: Form1.ryo = 0.114 * Form1.aleph: Form1.rzo = 0     ' genline different co-ord??
   Form1.rxf = 2.175 * offset_1 * Form1.aleph: Form1.ryf = 0.114 * Form1.aleph: Form1.rzf = -4.7 * Form1.aleph

   quad = 1
   genline3   ' genline3 generates line archetype data and stores in cyl_line_A&B matrices

   Form1.ryo = -Form1.ryo: Form1.ryf = -Form1.ryf '-0.114

   quad = 2
   genline3

   end_line = end_cyl_line_B
   
   Form1.rxo = 1.45 * offset_1 * Form1.aleph: Form1.ryo = 0.08 * Form1.aleph: Form1.rzo = -0.15 * Form1.aleph
   Form1.rxf = 1.45 * offset_1 * Form1.aleph: Form1.ryf = 0.08 * Form1.aleph: Form1.rzf = -4.925 * Form1.aleph

   quad = 3
   genline3

   Form1.ryo = -Form1.ryo: Form1.ryf = -Form1.ryf

   quad = 4
   genline3


Next

Form1.thstrF = thstr_hold
Form1.phstrF = phstr_hold
Form1.omstrF = omstr_hold

''Call cntrl_transpose
   


'Call matrix_multiply

End Sub

Public Sub apollo_run_data()

If Form1.restart Then
   phistar = -pi / 64
   Call matrix_transfer
   Call trans_phi(phistar)
End If

For node = 1 To 5         ' plot conic hyperbolas (command module)
   
   For a_star = 1 To a_dta
      
      Form1.clrcntrl = -1
      
      Form1.xprmI = apollo_last_L(node, a_star, 1)
      Form1.yprmI = apollo_last_L(node, a_star, 2)
      Form1.zprmI = apollo_last_L(node, a_star, 3)
      
      Form1.imagine
      Form1.pointset
       
      Form1.xprmI = apollo_last_R(node, a_star, 1)
      Form1.yprmI = apollo_last_R(node, a_star, 2)
      Form1.zprmI = apollo_last_R(node, a_star, 3)
             
      Form1.imagine
      Form1.pointset
       
      Form1.clrcntrl = 0
      
      Form1.rx = apollo_data_L(node, a_star, 1)
      Form1.ry = apollo_data_L(node, a_star, 2)
      Form1.rz = apollo_data_L(node, a_star, 3)
       
      'form1.rotate
      If Form1.matrix_flag Then
         Call matrix_multiply
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)
      
      Form1.imagine
      Form1.pointset

      apollo_last_L(node, a_star, 1) = Form1.xprmI
      apollo_last_L(node, a_star, 2) = Form1.yprmI
      apollo_last_L(node, a_star, 3) = Form1.zprmI

      Form1.rx = apollo_data_R(node, a_star, 1)
      Form1.ry = apollo_data_R(node, a_star, 2)
      Form1.rz = apollo_data_R(node, a_star, 3)
            
     ' form1.rotate
      If Form1.matrix_flag Then
         Call matrix_multiply
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)
      
      Form1.imagine
      Form1.pointset

      apollo_last_R(node, a_star, 1) = Form1.xprmI
      apollo_last_R(node, a_star, 2) = Form1.yprmI
      apollo_last_R(node, a_star, 3) = Form1.zprmI


   Next

Next

'thestar_hold = Form1.thestar
'Form1.thestar = thstr_5 / 2

'Call temp_cntrl
'Call compound_rotate(Form1.thestar)

'----------------------------------------------------------------------------------------------------

Form1.clrcntrl = -1
                                 ' plot circle data (all modules)
For c_star = 1 To dpts
     
      Form1.xprmI = cm_circle_last_1(c_star, 1)
      Form1.yprmI = cm_circle_last_1(c_star, 2)
      Form1.zprmI = cm_circle_last_1(c_star, 3)
      
      Form1.imagine
      Form1.pointset
Next

Form1.clrcntrl = 0

For c_star = 1 To dpts
      
      Form1.rx = apollo_circle_cm_1(c_star, 1)
      Form1.ry = apollo_circle_cm_1(c_star, 2)
      Form1.rz = apollo_circle_cm_1(c_star, 3)
       
      If Form1.matrix_flag Then
         Call matrix_multiply 'compound
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)
      
      Form1.imagine
      Form1.pointset

      cm_circle_last_1(c_star, 1) = Form1.xprmI
      cm_circle_last_1(c_star, 2) = Form1.yprmI
      cm_circle_last_1(c_star, 3) = Form1.zprmI
       
Next
      
Form1.clrcntrl = -1
      
For c_star = 1 To dpts
      
      Form1.xprmI = cm_circle_last_2(c_star, 1)
      Form1.yprmI = cm_circle_last_2(c_star, 2)
      Form1.zprmI = cm_circle_last_2(c_star, 3)
             
      Form1.imagine
      Form1.pointset
Next

Form1.clrcntrl = 0
      
For c_star = 1 To dpts
      
      Form1.rx = apollo_circle_cm_2(c_star, 1)
      Form1.ry = apollo_circle_cm_2(c_star, 2)
      Form1.rz = apollo_circle_cm_2(c_star, 3)
            
      If Form1.matrix_flag Then
         Call matrix_multiply 'compound
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)
      
      Form1.imagine
      Form1.pointset

      cm_circle_last_2(c_star, 1) = Form1.xprmI
      cm_circle_last_2(c_star, 2) = Form1.yprmI
      cm_circle_last_2(c_star, 3) = Form1.zprmI
           
Next
      
Form1.clrcntrl = -1

For c_star = 1 To dpts
      
      Form1.xprmI = sm_circle_last_1(c_star, 1)
      Form1.yprmI = sm_circle_last_1(c_star, 2)
      Form1.zprmI = sm_circle_last_1(c_star, 3)
             
      Form1.imagine
      Form1.pointset
Next

Form1.clrcntrl = 0

For c_star = 1 To dpts
     
      Form1.rx = apollo_circle_sm_1(c_star, 1)
      Form1.ry = apollo_circle_sm_1(c_star, 2)
      Form1.rz = apollo_circle_sm_1(c_star, 3)
            
      If Form1.matrix_flag Then
         Call matrix_multiply 'compound
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)
      
      Form1.imagine
      Form1.pointset

      sm_circle_last_1(c_star, 1) = Form1.xprmI
      sm_circle_last_1(c_star, 2) = Form1.yprmI
      sm_circle_last_1(c_star, 3) = Form1.zprmI
                      
Next
      
Form1.clrcntrl = -1

For c_star = 1 To dpts

      Form1.xprmI = sm_circle_last_2(c_star, 1)
      Form1.yprmI = sm_circle_last_2(c_star, 2)
      Form1.zprmI = sm_circle_last_2(c_star, 3)
             
      Form1.imagine
      Form1.pointset
Next

Form1.clrcntrl = 0
      
For c_star = 1 To dpts
      
      Form1.rx = apollo_circle_sm_2(c_star, 1)
      Form1.ry = apollo_circle_sm_2(c_star, 2)
      Form1.rz = apollo_circle_sm_2(c_star, 3)
            
      If Form1.matrix_flag Then
         Call matrix_multiply 'compound
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)
      
      Form1.imagine
      Form1.pointset

      sm_circle_last_2(c_star, 1) = Form1.xprmI
      sm_circle_last_2(c_star, 2) = Form1.yprmI
      sm_circle_last_2(c_star, 3) = Form1.zprmI
Next
      
Form1.clrcntrl = -1

For c_star = 1 To dpts

      Form1.xprmI = sm_circle_last_3(c_star, 1)
      Form1.yprmI = sm_circle_last_3(c_star, 2)
      Form1.zprmI = sm_circle_last_3(c_star, 3)
             
      Form1.imagine
      Form1.pointset
Next

Form1.clrcntrl = 0

For c_star = 1 To dpts

      Form1.rx = apollo_circle_sm_3(c_star, 1)
      Form1.ry = apollo_circle_sm_3(c_star, 2)
      Form1.rz = apollo_circle_sm_3(c_star, 3)
            
      If Form1.matrix_flag Then
         Call matrix_multiply 'compound
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)
      
      Form1.imagine
      Form1.pointset

      sm_circle_last_3(c_star, 1) = Form1.xprmI
      sm_circle_last_3(c_star, 2) = Form1.yprmI
      sm_circle_last_3(c_star, 3) = Form1.zprmI
       
Next
      
Form1.clrcntrl = -1

For c_star = 1 To dpts

      Form1.xprmI = nz_circle_last_1(c_star, 1)
      Form1.yprmI = nz_circle_last_1(c_star, 2)
      Form1.zprmI = nz_circle_last_1(c_star, 3)
             
      Form1.imagine
      Form1.pointset
Next

Form1.clrcntrl = 0
      
For c_star = 1 To dpts
      
      Form1.rx = apollo_circle_nz_1(c_star, 1)
      Form1.ry = apollo_circle_nz_1(c_star, 2)
      Form1.rz = apollo_circle_nz_1(c_star, 3)
            
      If Form1.matrix_flag Then
         Call matrix_multiply 'compound
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)
      
      Form1.imagine
      Form1.pointset

      nz_circle_last_1(c_star, 1) = Form1.xprmI
      nz_circle_last_1(c_star, 2) = Form1.yprmI
      nz_circle_last_1(c_star, 3) = Form1.zprmI
      
Next
      
Form1.clrcntrl = -1

For c_star = 1 To dpts

      Form1.xprmI = nz_circle_last_2(c_star, 1)
      Form1.yprmI = nz_circle_last_2(c_star, 2)
      Form1.zprmI = nz_circle_last_2(c_star, 3)
             
      Form1.imagine
      Form1.pointset
Next

Form1.clrcntrl = 0
      
For c_star = 1 To dpts
      
      Form1.rx = apollo_circle_nz_2(c_star, 1)
      Form1.ry = apollo_circle_nz_2(c_star, 2)
      Form1.rz = apollo_circle_nz_2(c_star, 3)
            
      If Form1.matrix_flag Then
         Call matrix_multiply 'compound
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)
      
      Form1.imagine
      Form1.pointset

      nz_circle_last_2(c_star, 1) = Form1.xprmI
      nz_circle_last_2(c_star, 2) = Form1.yprmI
      nz_circle_last_2(c_star, 3) = Form1.zprmI
      
Next
      
Form1.clrcntrl = -1

For c_star = 1 To dpts

      Form1.xprmI = nz_circle_last_3(c_star, 1)
      Form1.yprmI = nz_circle_last_3(c_star, 2)
      Form1.zprmI = nz_circle_last_3(c_star, 3)
             
      Form1.imagine
      Form1.pointset
Next

Form1.clrcntrl = 0
      
For c_star = 1 To dpts
      
      Form1.rx = apollo_circle_nz_3(c_star, 1)
      Form1.ry = apollo_circle_nz_3(c_star, 2)
      Form1.rz = apollo_circle_nz_3(c_star, 3)
            
      If Form1.matrix_flag Then
         Call matrix_multiply 'compound
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)
      
      Form1.imagine
      Form1.pointset

      nz_circle_last_3(c_star, 1) = Form1.xprmI
      nz_circle_last_3(c_star, 2) = Form1.yprmI
      nz_circle_last_3(c_star, 3) = Form1.zprmI

Next
      
Form1.clrcntrl = -1

For c_star = 1 To dpts

      Form1.xprmI = nz_circle_last_4(c_star, 1)
      Form1.yprmI = nz_circle_last_4(c_star, 2)
      Form1.zprmI = nz_circle_last_4(c_star, 3)
             
      Form1.imagine
      Form1.pointset
Next

Form1.clrcntrl = 0
      
For c_star = 1 To dpts
      
      Form1.rx = apollo_circle_nz_4(c_star, 1)
      Form1.ry = apollo_circle_nz_4(c_star, 2)
      Form1.rz = apollo_circle_nz_4(c_star, 3)
            
      If Form1.matrix_flag Then
         Call matrix_multiply 'compound
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)
      
      Form1.imagine
      Form1.pointset

      nz_circle_last_4(c_star, 1) = Form1.xprmI
      nz_circle_last_4(c_star, 2) = Form1.yprmI
      nz_circle_last_4(c_star, 3) = Form1.zprmI

Next
''''''' begin writing circle data ''''    transferred above here nested with erase_data

   'Next   ' all this has changed now :  fixed and float modes work 28 feb 2003   pfm


'----------------------------------------------------------------------------------------------------


''phstr_hold = Form1.phistar
''omstr_hold = Form1.omstar
 
''Form1.thestar = 0    ': Form1.phstrF = 0: Form1.omstrF = 0
''omstr_zero = omstr_5 / 2

'thstr_zero = form1.thestar + thstr_5 / 2   '  this one worked at before matrix

''Form1.thestar = Form1.thestar + thstr_zero

'Call temp_cntrl
'Call compound_rotate(Form1.thestar)

'Call temp_transfer
Form1.bright_save = Form1.bright_cntrl    ' lines too bright; turn off bright_control
Form1.bright_cntrl = False

'thstr_hold = Form1.thestar
'Form1.thestar = thstr_5 / 2

'Form1.thestar = thstr_5       ' 3_d line genrator, put in own subroutine? use in apollo_gen_data ?
For node = 1 To 5              ' generator now above; plot line data here (service module)
    
'   Call temp_transfer
'   Call compound_rotate(Form1.thestar)

   Form1.clrcntrl = -1
   end_line = end_cyl_line_A
   For l_dta = 0 To end_cyl_line_A
  
      end_line = end_cyl_line_A
      Form1.ImL = last_cyl_line_A(1, node, l_dta, 1)
      Form1.ImR = last_cyl_line_A(1, node, l_dta, 2)
      Form1.ImY = last_cyl_line_A(1, node, l_dta, 3)
      Form1.ImC = last_cyl_line_A(1, node, l_dta, 4)
    
      Form1.pointset

   Next
   
   Form1.clrcntrl = 0
   For l_dta = 0 To end_cyl_line_A
   
      Form1.rx = cylndr_line_A(1, node, l_dta, 1)
      Form1.ry = cylndr_line_A(1, node, l_dta, 2)
      Form1.rz = cylndr_line_A(1, node, l_dta, 3)

      If Form1.matrix_flag Then
         Call matrix_multiply
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)

      Form1.imagine
      Form1.pointset
   
      last_cyl_line_A(1, node, l_dta, 1) = Form1.ImL
      last_cyl_line_A(1, node, l_dta, 2) = Form1.ImR
      last_cyl_line_A(1, node, l_dta, 3) = Form1.ImY
      last_cyl_line_A(1, node, l_dta, 4) = Form1.ImC
   
   Next
   
   Form1.clrcntrl = -1
   For l_dta = 0 To end_cyl_line_A

      Form1.ImL = last_cyl_line_A(2, node, l_dta, 1)
      Form1.ImR = last_cyl_line_A(2, node, l_dta, 2)
      Form1.ImY = last_cyl_line_A(2, node, l_dta, 3)
      Form1.ImC = last_cyl_line_A(2, node, l_dta, 4)

      Form1.pointset
   Next
   
   Form1.clrcntrl = 0
   For l_dta = 0 To end_cyl_line_A
   
      Form1.rx = cylndr_line_A(2, node, l_dta, 1)
      Form1.ry = cylndr_line_A(2, node, l_dta, 2)
      Form1.rz = cylndr_line_A(2, node, l_dta, 3)

      If Form1.matrix_flag Then
         Call matrix_multiply
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)

      Form1.imagine
      Form1.pointset
   
      last_cyl_line_A(2, node, l_dta, 1) = Form1.ImL
      last_cyl_line_A(2, node, l_dta, 2) = Form1.ImR
      last_cyl_line_A(2, node, l_dta, 3) = Form1.ImY
      last_cyl_line_A(2, node, l_dta, 4) = Form1.ImC

   Next

   Form1.clrcntrl = -1
   end_line = end_cyl_line_B
   For l_dta = 0 To end_cyl_line_B

      Form1.ImL = last_cyl_line_B(1, node, l_dta, 1)
      Form1.ImR = last_cyl_line_B(1, node, l_dta, 2)
      Form1.ImY = last_cyl_line_B(1, node, l_dta, 3)
      Form1.ImC = last_cyl_line_B(1, node, l_dta, 4)

      Form1.pointset
   Next
   
   Form1.clrcntrl = 0
   For l_dta = 0 To end_cyl_line_B
  
      Form1.rx = cylndr_line_B(1, node, l_dta, 1)
      Form1.ry = cylndr_line_B(1, node, l_dta, 2)
      Form1.rz = cylndr_line_B(1, node, l_dta, 3)

      If Form1.matrix_flag Then
         Call matrix_multiply
      Else
         Form1.rotate
      End If

      Form1.xprmI = pix * (Form1.xref + Form1.deltx)
      Form1.yprmI = pix * (Form1.yref + Form1.delty)
      Form1.zprmI = pix * (Form1.zref + Form1.deltz)

      Form1.imagine
      Form1.pointset
     
      last_cyl_line_B(1, node, l_dta, 1) = Form1.ImL
      last_cyl_line_B(1, node, l_dta, 2) = Form1.ImR
      last_cyl_line_B(1, node, l_dta, 3) = Form1.ImY
      last_cyl_line_B(1, node, l_dta, 4) = Form1.ImC
     
   Next
   
   Form1.clrcntrl = -1
   For l_dta = 0 To end_cyl_line_B

      Form1.ImL = last_cyl_line_B(2, node, l_dta, 1)
      Form1.ImR = last_cyl_line_B(2, node, l_dta, 2)
      Form1.ImY = last_cyl_line_B(2, node, l_dta, 3)
      Form1.ImC = last_cyl_line_B(2, node, l_dta, 4)

      Form1.pointset
   Next
   
   Form1.clrcntrl = 0
   For l_dta = 0 To end_cyl_line_B
  
     Form1.rx = cylndr_line_B(2, node, l_dta, 1)
     Form1.ry = cylndr_line_B(2, node, l_dta, 2)
     Form1.rz = cylndr_line_B(2, node, l_dta, 3)

     If Form1.matrix_flag Then
        Call matrix_multiply
     Else
        Form1.rotate
     End If

     Form1.xprmI = pix * (Form1.xref + Form1.deltx)
     Form1.yprmI = pix * (Form1.yref + Form1.delty)
     Form1.zprmI = pix * (Form1.zref + Form1.deltz)

     Form1.imagine
     Form1.pointset
     
     last_cyl_line_B(2, node, l_dta, 1) = Form1.ImL
     last_cyl_line_B(2, node, l_dta, 2) = Form1.ImR
     last_cyl_line_B(2, node, l_dta, 3) = Form1.ImY
     last_cyl_line_B(2, node, l_dta, 4) = Form1.ImC

   Next
  
Next

'Form1.thestar = thestar_hold
'Form1.phistar = phstr_hold
'Form1.omstar = omstr_hold

Form1.bright_cntrl = Form1.bright_save
End Sub

Public Sub genline3()   ' first generic line generator ' converted to service module line generate
Form1.dirx = Form1.rxf - Form1.rxo: Form1.diry = Form1.ryf - Form1.ryo: Form1.dirz = Form1.rzf - Form1.rzo
'abr = Sqr(dirx ^ 2 + diry ^ 2 + dirz ^ 2)
'endlm = CLng(100 * abr / dtln) / 100
'modify      set end_cyl_line at call subroutine/s
'end_line = apollo1.end_cyl_line


For n_line = 0 To end_line

  Form1.rxx = Form1.rxo + n_line * Form1.dirx / end_line
  Form1.ryy = Form1.ryo + n_line * Form1.diry / end_line
  Form1.rzz = Form1.rzo + n_line * Form1.dirz / end_line

 ' rotate
        'If Form1.matrix_flag Then
        ' Call matrix_compound
      'Else
         Form1.rotateF
      'End If

  'rx = deltx: ry = delty: rz = deltz
  'rotate
  
  If quad = 1 Or quad = 2 Then
  
  cylndr_line_A(quad, node, n_line, 1) = Form1.deltx 'pix * (Form1.xref + Form1.deltx)
  cylndr_line_A(quad, node, n_line, 2) = Form1.delty 'pix * (Form1.yref + Form1.delty)
  cylndr_line_A(quad, node, n_line, 3) = Form1.deltz 'pix * (Form1.zref + Form1.deltz)
  
  Else
  
  cylndr_line_B(quad - 2, node, n_line, 1) = Form1.deltx 'pix * (Form1.xref + Form1.deltx)
  cylndr_line_B(quad - 2, node, n_line, 2) = Form1.delty 'pix * (Form1.yref + Form1.delty)
  cylndr_line_B(quad - 2, node, n_line, 3) = Form1.deltz 'pix * (Form1.zref + Form1.deltz)
  
  End If
  
  'Form1.xprmI = cylndr_line_A(quad, node, n_line, 1)
  'Form1.yprmI = cylndr_line_A(quad, node, n_line, 2)
  'Form1.zprmI = cylndr_line_A(quad, node, n_line, 3)

  'Form1.xprmI = cylndr_line_B(quad, node, n_line, 1)
  'Form1.yprmI = cylndr_line_B(quad, node, n_line, 2)
  'Form1.zprmI = cylndr_line_B(quad, node, n_line, 3)
  
  
  'xprmI = pix * (xref + deltx)
  'yprmI = pix * (yref + delty)
  'zprmI = pix * (zref + deltz)
  
'  clrcntrl = 0
'
'  imagine
'  pointset

'  If quad = 1 Or quad = 2 Then
'    last_cyl_line_A(quad, node, n_line, 1) = ImL
'    last_cyl_line_A(quad, node, n_line, 2) = ImR
'    last_cyl_line_A(quad, node, n_line, 3) = ImY
'    last_cyl_line_A(quad, node, n_line, 4) = ImC
'  Else
'    last_cyl_line_B(quad - 2, node, n_line, 1) = ImL
'    last_cyl_line_B(quad - 2, node, n_line, 2) = ImR
'    last_cyl_line_B(quad - 2, node, n_line, 3) = ImY
'    last_cyl_line_B(quad - 2, node, n_line, 4) = ImC
'  End If
Next
'end_cyllm_lst ''(ln_nmbr) = endlm
'ln_nmbr_lst = ln_nmbr
End Sub




